/*
 * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS HEADER.
 *
 * The contents of this file are subject to the terms of either the GNU
 * General Public License Version 2 only ("GPL") or the Common
 * Development and Distribution License("CDDL") (collectively, the
 * "License"). You may not use this file except in compliance with the
 * License. You can obtain a copy of the License at
 * http://www.netbeans.org/cddl-gplv2.html
 * or nbbuild/licenses/CDDL-GPL-2-CP. See the License for the
 * specific language governing permissions and limitations under the
 * License.  When distributing the software, include this License Header
 * Notice in each file and include the License file at
 * nbbuild/licenses/CDDL-GPL-2-CP.  Sun designates this
 * particular file as subject to the "Classpath" exception as provided
 * by Sun in the GPL Version 2 section of the License file that
 * accompanied this code. If applicable, add the following below the
 * License Header, with the fields enclosed by brackets [] replaced by
 * your own identifying information:
 * "Portions Copyrighted [year] [name of copyright owner]"
 *
 * Contributor(s):
 *
 * Portions Copyrighted 2009 Jaroslav Tulach
 */

package cz.xelfi.quoridor.emailer

import scala.xml._
import java.net.URL
import scala.io._
import scala.collection.Map
import scala.collection.mutable.HashMap
import javax.mail.internet._
import javax.mail.Message
import javax.mail.Transport

abstract class Notify {
  protected def allPlayers(): Map[String,List[Node]]
  protected def emails(ids : Collection[String]): List[String]
  protected def sendEmail(address : String, subject : String, text : String) : Unit

  def process() {
    val ret = allPlayers()

    for (val address <- emails(ret.keySet)) {
        Console.println("Sending message to " + address)

        sendEmail(
          "quoridor@xelfi.cz",
          "Play Quoridor!",
          "Visit http://quoridor.xelfi.cz"
        )
    }
  }
}
